/*
   debug.c -- PIKT pikt & piktd debug routines

   $Header: /var/cvs/PIKT/pikt/src/piktd/debug.c,v 1.25 2005/01/04 13:49:04 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998,1999,2000,2001,2002,2003,2004,2005 by Robert Osterlund.

   PIKT is a trademark of the University of Chicago.  All Rights Reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   Send problem reports, bouquets and brickbats to:  pikt-bugs@pikt.org
 */

#include "../lib/common.h"
#include "piktd.h"

const char *statements[] = {
				"",
				"DO",
				"IF",
				"ELIF",
				"ELSE",
				"ENDIF",
				"WHILE",
				"ENDWHILE",
				"REPEAT",
				"UNTIL",
				"FOR",
				"ENDFOR",
				"BREAK",
				"CONTINUE",
				"SWITCH",
				"CASE",
				"DEFAULT",
				"BREAKSWITCH",
				"ENDSWITCH",
				"AGAIN",
				"LEAVE",
				"REDO",
				"NEXT",
				"SKIP",
				"LAST",
				"PAUSE",
				"QUIT",
				"DIE",
				"OUTPUT",
				"MAIL",
				"PRINT",
				"LOCLOG",
				"PIKTLOG",
				"SYSLOG",
				"SET",
				"UNSET",
				"EXEC",
				"EXECWAIT",	/* 37 */
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"WHILEAUX",	/* 107 */
				"",
				"REPEATAUX",	/* 109 */
				"",
				"FORAUX"	/* 111 */
			      };

/* dump to logreturn() all vals
 */
void
dumpvals(val *values)
{
	#ifdef DEEPDEBUG
	static char fnnam[] = "dumpvals";
	val *valp;
	vl *vlp, *initvlp;
	register int i, j;

	foreach (valp, values) {
		for (i=1; i<=VRNDXHI; i++) {
			for (j=0; j<=9; j++) {
				vlp = initvlp = valp->vals[i][j];
				while (vlp) {
					if (vlp->str)
						logreturn(PIKTLOG, LOG_DEBUG, ERRID_DEBUG, __FILE__, __LINE__, fnnam, FALSE, "%s", vlp->str);
					if (vlp->num != NILARNDX)
						logreturn(PIKTLOG, LOG_DEBUG, ERRID_DEBUG, __FILE__, __LINE__, fnnam, FALSE, "%f", vlp->num);
					vlp = vlp->next;
					if (vlp == initvlp)
						break;
				}
			}
		}
	}
	return;
	#endif
	return;
}

/* dump linking info for all program statements
 */
void
dumpsps (stm *sps, char *message)
{
	#ifdef DEEPDEBUG
	static char fnnam[] = "dumpsps";
	stm *sp;

	logreturn(PIKTLOG, LOG_DEBUG, ERRID_DEBUG, __FILE__, __LINE__, fnnam, FALSE, "\n\n%-30s statement   type    sp tnext fnext   aux  next", message);
	foreach(sp, sps) {
		logreturn(PIKTLOG, LOG_DEBUG, ERRID_DEBUG, __FILE__, __LINE__, fnnam, FALSE, "               %-12s %3d %5x %5x %5x %5x %5x", statements[sp->type], sp->type, sp, sp->tnext, sp->fnext, sp->aux, sp->next);
	}
	fprintf(stderr, "\n");
	fflush(stderr);
	#endif
	return;
}

void
dumptime (char *timestr, unsigned long time)
{
	#ifdef DEEPDEBUG
	register int i;
	unsigned long mask;

	printf("%s\t", timestr);
	for (i=8*sizeof(unsigned long)-1; i>=0; i--) {
		mask = (1L << i);
		printf("%c", time & mask ? '1' : '0');
		if (!(i % 8))
			printf(" ");
	}
	printf("\n");
	#endif
	return;
}

/*
void
dumpalarms ()
{
	return;
}
 */
